' Gutenberg v0.95 - by Geoff Camp (aka goksteroo) 2021
'
' A book reader for text based books from Project Gutenberg's library.
' 59 books plus instructions/Gutenberg User License included'


' Edit these lines for different fonts/modes
const rd_mode=12' Read Mode
const rd_fnt=4' Read Font
const mnu_mode=12' Menu Mode
const mnu_fnt=2' Menu Font

load bmp "gutenberg2.bmp",mm.hres/2-120,mm.vres/2-100
text mm.hres/2,0,"Read:  Mode "+str$(rd_mode)+"   Font "+str$(rd_fnt),c,1,,rgb(yellow),rgb(black)
text mm.hres/2,12,"Menu:  Mode "+str$(mnu_mode)+"   Font "+str$(mnu_fnt),c,1,,rgb(yellow),rgb(black)
text mm.hres/2,24,"(set these in the first 4 lines of code)",c,1,,rgb(red),rgb(black)

option explicit
option default integer
option base 1

#include "books.inc"
#include "gut_col.inc"
framebuffer create 1600,1200' 1,920,000 bytes for book

dim nl' new line flag
dim pp$' builds line of text
dim b_num' book number
dim fntht' font height
dim wide' page width
dim b_page' calc. page jump
dim i,j,x' counters
dim xit' exit flag
dim fg(16),bg(16)' colour pairs
dim col_cnt' col scheme count
dim b_cnt' book count
dim menu' book list #
dim zz' temp char count
dim hp' horiz pos
dim vp' vert pos
dim s$' spaces
dim nxt_page' next page flag
dim old_page' start of current page
dim chr_cnt' character count
dim p' peek chrs
dim lin_count' line count
dim turn' flag
dim f$' general string
dim old_b' old book in list
dim b_length' length of book
dim om' booklist flag
dim hf_size' used in header/footer

text mm.hres/2,mm.vres-12," Press [SPACE] to start] ",c,1,,rgb(yellow),rgb(black)
do
j=keydown(1)
loop until j=32

mode rd_mode
font rd_fnt
fntht=mm.info(fontheight)
if fntht=8 then fntht=10 ' font 7 is 8 pixel high, uses 10 pixel spacing

const fntwid=mm.info(fontwidth)
const widest=int(mm.hres/fntwid)' maximum chars per line
const lines=int((mm.vres-24)/fntht)' 2 less for head/foot
const b_add=mm.info(framebuffer)
const p_perc=0.7' % of calc page to jump forward/back

wide=widest' actual chars per line
b_page=(wide*lines)*p_perc' skip size

'initialise book list, authors, files, last read postion

restore Books
read b_num

dim b_name$(b_num),b_author$(b_num),b_file$(b_num),b_pos(b_num)

open "books.dat" for input as #1
for i=1 to b_num
  input #1,b_pos(i)
  read b_name$(i),b_author$(i),b_file$(i)
  b_file$(i)=b_file$(i)+".txt"
next i
close #1

' set colour schemes

fg(1)=mm.info(fcolour) ' current fg/bg colours
bg(1)=mm.info(bcolour)
restore col_schemes ' read colours
for i=2 to 16
  read bg(i),fg(i)
next i
col_cnt=1 ' scheme count
b_cnt=1 ' selected book

'main loop

do
  mode mnu_mode,8
  cls
  font mnu_fnt
  menu=1 ' 1st book list
  booklist
  choosebook
  rd_book
    do while keydown(0)>0
    loop
loop

end

' read book

sub rd_book

mode rd_mode,8 ' set mode, pen, paper, font
map(0)=bg(col_cnt)
map(1)=fg(col_cnt)
map set
colour map(1),map(0)
cls
header b_name$(b_num)+" - "+b_author$(b_num),1
footer "SPC-turn page "+chr$(144)+"-skip up/down "+chr$(145)+"-colours HOME-restart S-save Q-quit"
font rd_fnt

chr_cnt=b_pos(b_num)
xit=0
print @(0,12);
lin_count=1
pp$=""
zz=chr_cnt' count for current page
hp=(int((widest-wide)/2)*fntwid)
s$=space$(int(widest-wide)/2)
nxt_page=0
do
  if lin_count=1 and nxt_page=0 then old_page=chr_cnt
  nxt_page=1
  p=peek(byte b_add+chr_cnt)
  vp=mm.info(vpos)
  nl=0
  select case p
    case 32 to 127
      pp$=pp$+chr$(p)
    case 13
      print @(hp,vp)pp$;
      nl=1
      pp$=""
      inc chr_cnt
      inc lin_count
    case 0' end of book
      xit=1
      print @(hp,vp)pp$;
      footer "End of book - Press [Q] to continue"
      do
      f$=ucase$(inkey$)      
      loop until f$="Q"
  end select
  if len(pp$)>wide then 
    truncate
    print @(hp,vp)pp$;
    pp$=""
    nl=1
  end if
  if nl=1 and lin_count<=lines then print
  inc chr_cnt
  if lin_count>lines then
    nxt_page=0
    text 0,mm.vres-10," "+str$(int(zz*100/b_length))+"% ",l,7,,map(0),map(1)
    zz=chr_cnt
    turn=0  
    do
      j=keydown(1)
      select case j
        case 32' next page
          turn=1
         case 128,136' jump back
         inc old_page,-b_page
         if old_page<0 then old_page=0
          chr_cnt=old_page
          turn=1
        case 129,137' jump forward
          inc old_page,b_page
          if old_page=>b_length then inc old_page,-b_page
          chr_cnt=old_page
          turn=1
        case 83,115' save
          b_pos(b_num)=old_page
          open "books.dat" for output as #1
          for i=1 to 60
            print #1,b_pos(i)
          next i
          header b_name$(b_num)+" - "+b_author$(b_num),1
        close #1
        case 130
          inc col_cnt,-1
          new_scheme
          pause 100
        case 131
          inc col_cnt
          new_scheme
          pause 100
        case 113,81' quit
          turn=1
          xit=1
        case 49 to 57' 1-9 width 10-90%
          wide=widest*((j-48)/10)
          turn=1
          s$=space$(int(widest-wide)/2)
          chr_cnt=old_page
          b_page=(wide*lines)*p_perc
          hp=(int((widest-wide)/2)*fntwid)
          box 0,12,mm.hres,mm.vres-24,0,map(0),map(0)
        case 48 '0 width 100%
          wide=widest
          turn=1
          s$=space$(int(widest-wide)/2)
          chr_cnt=old_page
          b_page=(wide*lines)*p_perc
          hp=0
        case 134' home - begin again
          chr_cnt=0
          old_page=0
          turn=1
          text 0,mm.vres-10,"0% ",l,7,,map(0),map(1)
       end select

    loop until turn=1
  box hp,12,wide*fntwid,mm.vres-24,0,map(0),map(0)
  print @(0,12);
  lin_count=1
if j=32 then pause 150 ' turn only 1 page
endif

loop until xit=1

end sub

' Split line at a space

sub truncate

  x=len(pp$)
    do
      inc x,-1
      inc chr_cnt,-1
      if x=0 then' longer than wide, no spaces
        x=int(wide/2)
        chr_cnt=chr_cnt+x
        exit do
      endif
    loop until mid$(pp$,x,1)=" "
  pp$=left$(pp$,x)
  inc lin_count

end sub

' Print booklist

sub booklist

map(0)=bg(col_cnt)
map(1)=fg(col_cnt)
map set
colour map(1),map(0)
cls
header "Gutenberg Books - G Camp 2021",0
text 20,mm.info(fontheight),"Book List #"+str$(menu),l,mnu_fnt,,map(1),map(0)
for i=1 to 20
  b_num=(menu-1)*20+i
  text 0,(i+1)*mm.info(fontheight),b_name$(b_num)+" - "+b_author$(b_num),l,mnu_fnt,,map(1),map(0)
next i
b_num=(menu-1)*20+1
b_cnt=1
text 0,(b_cnt+1)*mm.info(fontheight),b_name$(b_num)+" - "+b_author$(b_num),l,mnu_fnt,,map(0),map(1)
footer chr$(144)+" select book SPC read 1-3 book list "+chr$(145)+" colours Q quit"

end sub

' Select book

sub choosebook

do
  om=menu
  pause 100
  old_b=b_cnt
  j=keydown(1)
  select case j
    case 128,136
      inc b_cnt,-1
      if b_cnt<1 then b_cnt=20
    case 129,137
      inc b_cnt
          if b_cnt>20 then b_cnt=1
    case 130
      inc col_cnt,-1
      new_scheme
    case 131
      inc col_cnt
      new_scheme
    case 49 to 51' 1-3
      menu=j-48
    case 113,81' quit
      cls
      end 
  end select
  if om<>menu then booklist  
  b_num=(menu-1)*20+b_cnt
  if b_cnt<>old_b then
    text 0,(b_cnt+1)*mm.info(fontheight),b_name$(b_num)+" - "+b_author$(b_num),l,mnu_fnt,,map(0),map(1)
    text 0,(old_b+1)*mm.info(fontheight),b_name$((menu-1)*20+old_b)+" - "+b_author$((menu-1)*20+old_b),l,mnu_fnt,,map(1),map(0)
  end if

loop until j=32

box 0,12,mm.hres,mm.vres-24,0,map(0),map(0)
text mm.hres/2,mm.vres/2,"L O A D I N G",c,mnu_fnt,,map(1),map(0)
page write framebuffer
cls
page write 0
b_length=mm.info(filesize b_file$(b_num))
load data b_file$(b_num),b_add
do while keydown(0)>0
loop
end sub

' header - ? "save" if j=1

sub header z$,j

hf_size=mm.hres/8

f$=space$(80)+z$+space$(80)
f$=mid$(f$,len(f$)/2-hf_size/2,hf_size)
text mm.hres/2,0,f$,c,1,,map(0),map(1)
if j=1 then
  text mm.hres,2,"Save:"+str$(b_pos(b_num))+" ",r,7,,map(0),map(1)
endif

end sub

' footer

sub footer z$

hf_size=mm.hres/8
f$=space$(80)+z$+space$(80)
f$=mid$(f$,len(f$)/2-hf_size/2,hf_size)
text mm.hres/2,mm.vres-12,f$,c,1,,map(0),map(1)

end sub

' new colours

sub new_scheme

if col_cnt=0 then col_cnt=16
if col_cnt=17 then col_cnt=1
map(0)=bg(col_cnt)
map(1)=fg(col_cnt)
map set

end sub

